(* The zlib/libpng License

Copyright (c) 2005 Dirk Jagdmann <doj@cubic.org>

This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
   not claim that you wrote the original software. If you use this
   software in a product, an acknowledgment in the product
   documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must
   not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source
   distribution.
*)

program palette;

var r : array[1..6] of real;
var g : array[1..6] of real;
var b : array[1..6] of real;
var size :  integer;
/*
var x : integer;
var f : real;
*/

procedure i(c : real);
var f : real;
var x,y : integer;
begin

   f:=size-1;
   f:=1.0/f;
   x:=1;
   while (x<(size-1)) and (c>f) do begin
      x:=x+1;
      c:=c-f;
   end;
   y:=x+1;

   c:=c/f;
   setrgbcolor(r[x]*(1.0-c)+r[y]*c, g[x]*(1.0-c)+g[y]*c, b[x]*(1.0-c)+b[y]*c);
end;

begin

   size:=6;
   r[1]:=1; g[1]:=0; b[1]:=0.25;
   r[2]:=1; g[2]:=0; b[2]:=0;
   r[3]:=1; g[3]:=1; b[3]:=0;
   r[4]:=1; g[4]:=1; b[4]:=0;
   r[5]:=0; g[5]:=0; b[5]:=1;
   r[6]:=0; g[6]:=0; b[6]:=0.2;

/*
   f := 0;
   for x := 1 to 51 do begin
      i(f);
      writeln(f);
      f:=f+0.02;
   end;
   showpage();
*/
end.
